; Tern (Terrain)                                     :
; a 64-byte intro by rrrola <rrrola@gmail.com>       :tt   NN
; greets to everyone who likes hiking         .    :ttttttENN
;....       .                               ..:.t::tttteeRENN
;tttt:..:..:..::                        . .t:tttteeRRtteeRENN tee
;eRttteRtReRRtttt: . .               . .:.:teRReRRRRRREENENNNNRee
;RReeRReRRRRRettttttttt..            ..teteeeRRRRRREEEENNENNNNNNN
;EEERRRRRRRRRRRetttttetttttt .   :  .:teeeRRRRRREEEEEENNNNNNNNNNN
;ENERERRERRRRRRReeeeeeeettttttt:tttt.ttRRRRERRREEEEENNNNNNNNNNNNN
;NNEEEEEEREERRRRRRRReReeeeteetetettttteRRREEEEEEEENNNNNNNNNNNNNNN

org 100h   ; assume ds<=0x249f ah=0 si=0x100 bp~0x91c

;68 f6 9f
  push 0xa000 - 160/16
;34 13
  xor al,13h    ; es=0x9ff6: centered screen segment
  pop es        ; dx=0xf668: more deterministic texture
  lds cx,[bx+si]   ; ds=0x349f: texture segment
  int 0x10  
;  db 0xcd       ; int 0x10 (set 320x200 mode); hlt

;Texture: compute a row (256 texels) of non-repeating 2D noise
;inspired by baze's texture generator from Tube, Lattice, Lander
T ;db 0x10,0xf4  ;=adc ah,dh  ; + random value (-16..15)

  ;db 0x13,0xd5  ;=adc dx,bp

  adc dx,bp

M adc dh,[si]; + top right neighbour [si-128+1]
  shr dx,1      ; average
  mov [si+127],dh   ; texel = (left + top_right + random + adc(0..2)) / 2

  rcr bp,cl
  sar bp,4      ; next random value (-16..15), mess up the top bits

  inc si        ; next texel: ah = left neighbour [si-1]
  loop T        ; si += 256; advance time

;Raymarch from the camera, compute the hit distance
;mul/imul trick from HellMood's Gespensterwald
R mov bh,7      ; bh=z (depth): 7..127 (7 prevents dithering underflow)
Z mov ax,0xcccd
  mul di        ; dh = unsigned y (0..200), dl = signed x (-128..128)
  mov al,dh
  mul bh        ; ah=y*z (unsigned because y can be > 127)
  xchg ax,dx    ; dh=y*z, al=x
  imul bh       ; ah=x*z (signed), al=fraction(x*z)
  mov bl,ah     ; bl=x*z
  cmp [bx+si],dh; hit if texture[x*z, z+time] < y*z?
  jb D
  inc bh        ; no hit: z++
  jns Z

;Dithering, illusion of light from the right side
D aam 37        ; ah=al/37 ~~ 7*fraction(x*z)
  sub ah,bh     ; ah -= z_hit (128..255)
  shr ax,11     ; al=ah/8 (16..31: grayscale), ah=0

;Next pixel
  stosb
  loop R
;Next frame
;  call SCREENSHOT
  mov ch,1      ; use "mov ch,2" to fly faster
  jmp M

;%include "screenshot.inc"
;db 0xd5,0xc0,0x00,0x00